--This function contains the stuff called by all the proc modules. Many thanks to Kragen for helping me with the fix, by telling me it needed it!

--Adds the events from the watchlist table.
function procwatcher()
	for a=1,#WatchList do
		AddCallback (PlayerAttributes,WatchList[a][2],WatchList[a][4])
	end
end

--procupdate - called by external modules to update ALL bars.
function procupdate()
	--Go to a special updater if this class has numeric procs. e.g. Runekeeper attunement.
	if numeric then numericprocupdate() end
	
	for j=1,#WatchList do
		local name=WatchList[j][1]
		if name~="n" then
			local flag=WatchList[j].flag
			showhide(name,flag)
		end
	end
end

--Function called when availability of a bar is changed. For "flag" type skills such as those used by a Guardian.
function changed(name,flag,arg)
	--Turbine.Shell.WriteLine(name.." has procced")
	--This function looks at the argument (For example IsBlockTier1Available()) and sets the flag correctly according to what it sees.
	--It is essentially a nasty hack due to the Turbine Bug - more details in the function.
		--if a proc is recieved and the flag is already true then WARNING! the next send will hide the proc, even though it is still up. This is due to a turbine bug where if you get the same proc twice it sends a "lose" afterwards.
		--So, this line sets a second flag to get around this.
		if flag.flag and arg then flag.warn=true end

		flag.flag=arg or flag.warn
		if flag.flag==nil then flag.flag=false end
		
		--If the warning flag is set and the argument is false then we can clear the flag.
		if flag.warn and not arg then flag.warn=false end
		
		--Now, go through all the bars and show those whose flag is set - by this name of course.
		showhide(name,flag.flag)
end

--This function runs through all the bars, looked for the ones that are marked "BT1" for example (name) and checks the flag "WatchList[1].flag" for example and either shows, or hides the bar as appropriate.
function showhide(name,flag)	
	for i=1,#Bar do
		if Bar[i].Data.proc==name then 
			if flag then
				Bar[i].Proc=true
				Bar[i]:Show() 
			else
				Bar[i].Proc=false
				Bar[i]:Hide()
			end 
		end
	end
end

--Add the "Proc Bar" option to every Bar.
table.insert(Context,
function (self,contextMenu,contextMenuItems)
	local procBar = Turbine.UI.MenuItem( "Show only when...");
		contextMenu.procs = procBar:GetItems()
		procMenu={}
			
	for i=1, #WatchList do
		if WatchList[i][1]=="n" then
			numericoption(self,contextMenu,contextMenuItems)
		else
			--Flag type proc
			procMenu[i] = Turbine.UI.MenuItem( WatchList[i][3],true,self.Data.proc==WatchList[i][1]);
			procMenu[i].Click = function( sender, args )
				if self.Data.proc==WatchList[i][1] then
					self.Data.proc=nil
				else
					self.Data.proc=WatchList[i][1]
				end
				procupdate()
			end
			contextMenu.procs:Add(procMenu[i])
		end
	end	
	contextMenuItems:Add( procBar )
	
	local FadeMenu=Turbine.UI.MenuItem("Proc Module should fade to...")
	contextMenu.Fade=FadeMenu:GetItems()
	FadeItems={}
	for i=1,10 do
		FadeItems[i]=Turbine.UI.MenuItem(i/10,true,(self.Data.fade==i/10))
			FadeItems[i].Click = function (sender, args)
				self.Data.fade=i/10
			end
		contextMenu.Fade:Add(FadeItems[i])
	end
		FadeItems[99]=Turbine.UI.MenuItem("Hide bar completely",true,(self.Data.fade==false or self.Data.fade==nil))
			FadeItems[99].Click = function (sender, args)
				self.Data.fade=nil
			end
		contextMenu.Fade:Add(FadeItems[99])
	contextMenu.procs:Add(FadeMenu)	
end)

--Initialise the bars and begin.
	
	Proc=true	--Flag to show a proc module is loaded
	procwatcher()
	procupdate ()
		
	table.insert(Opt.Module,
	function()

	Opt.ProcBox=CollapseBox("Proc Options","f",1,true)
	
	Opt.ListBox:AddItem(Opt.ProcBox)
	
	--Build tables for the Proc option: Based on WatchList and Numeric Proc
	ProcText={}
	ProcValue={}
	ProcLookup={}
	local k
	
	ProcText[1]="Not a proc bar"
	for i=1,#WatchList do
		if WatchList[i][1]~="n" then
			--non-numeric procs
			ProcText[i+1]=WatchList[i][3]
			ProcValue[i]=WatchList[i][1]
			ProcLookup[WatchList[i][1]]=i
		end
	end
	if NumericProc~=nil then
		local k=#WatchList-1
		for i=1,#NumericProc do
			ProcText[k+i+1]=NumericProc[i][1]
			ProcValue[k+i]=NumericProc[i][2]
			ProcLookup[NumericProc[i][2]]=k+i
		end
	end
	
	table.insert(Opt.source,"proc")
	Opt.proc=Opt.DropDown(
		ProcText,
		function(k,i)
			Bar[i].Data.proc=ProcValue[k]
			procupdate()
		end,
		"Proc on:")
		
	Opt.ProcBox.Content:AddItem(Opt.proc)
	
	table.insert(Opt.source,"fade")
	Opt.fade=Opt.DropDown(
		{	"Hide Bar completely",
			"10%",
			"20%",
			"30%",
			"40%",
			"50%",
			"60%",
			"70%",
			"80%",
			"90%",
			"100%"},
			function(k,i)
				Bar[i].Data.fade=k/10
				if k==0 then Bar[i].Data.fade=nil	end
				procupdate()
		end,
		"Fade to:")
	
	Opt.ProcBox.Content:AddItem(Opt.fade)
	

	end)
	
table.insert(Opt.Updaters, 
	function()
	if Opt.proc~=nil then
		Opt.proc:SetVal(ProcLookup[Opt.val.proc])
	end
end)

table.insert(Opt.Updaters, 
	function()
		if Opt.fade~=nil then
			local k=Opt.val.fade
			if k==nil then k=0 end
			Opt.fade:SetVal(k*10)
		end
	end)
	